lab_1/urls.py
from django.urls import path
from .views import index, friend_list

urlpatterns = [
    path('', index, name='index'),
    path('friends', friend_list)
]

lab_2/urls.py
from django.urls import path
from .views import index, xml, json

urlpatterns = [
    path('', index, name='index'),
    path('xml', xml, name='xml'),
    path('json', json, name='json')
]

lab_3/urls.py
from django.urls import path
from .views import index, add_friend

urlpatterns = [
    path('', index, name='index'),
    path('add', add_friend),
]

lab_4/urls.py
from django.urls import path
from .views import *

urlpatterns = [
    path('', index),
    path('add-note', add_note),
    path('note-list', note_list),
]

praktikum/urls.py
from django.urls import path, re_path, include
from django.contrib import admin
import lab_1.urls as lab_1
import lab_2.urls as lab_2
import lab_3.urls as lab_3
import lab_4.urls as lab_4

from lab_1.views import index as index_lab1

urlpatterns = [
    path('admin/', admin.site.urls, name="admin"),
    path('lab-1/', include(lab_1)),
    path('lab-2/', include(lab_2)),
    path('lab-3/', include(lab_3)),
    path('lab-4/', include(lab_4)),
    re_path(r'^$', index_lab1, name='index')
]

lab_1/models.py
from django.db import models

class Friend(models.Model):
    name = models.CharField(max_length=30)
    npm = models.IntegerField()
    birth_date = models.DateField()

lab_2/models.py
from django.db import models

# Create your models here.
class Note(models.Model):
    receiver = models.CharField(max_length=30)
    sender = models.CharField(max_length=30)
    title = models.CharField(max_length=30)
    message = models.CharField(max_length=50)

lab_3/models.py
from django.db import models
from lab_1.models import Friend

lab_4/models.py
from django.db import models

# Create your models here.
class Note(models.Model):
    receiver = models.CharField(max_length=30)
    sender = models.CharField(max_length=30)
    title = models.CharField(max_length=30)
    message = models.CharField(max_length=50)

lab_3/forms.py
from lab_1.models import Friend
from django import forms 

class FriendForm(forms.ModelForm):
    class Meta:
        model = Friend
        fields = ['name', 'npm', 'birth_date']

lab_4/forms.py
from .models import Note
from django import forms 

class NoteForm(forms.ModelForm):
    class Meta:
        model = Note
        fields = ['receiver', 'sender', 'title', 'message']

lab_1/views.py
from django.shortcuts import render
from datetime import datetime, date
from .models import Friend

mhs_name = 'Shadqi Marjan Sadiya'
curr_year = int(datetime.now().strftime("%Y"))
birth_date = date(2001, 11, 20)
npm = 2006596655  

def index(request):
    response = {'name': mhs_name,
                'age': calculate_age(birth_date.year),
                'npm': npm}
    return render(request, 'index_lab1.html', response)

def calculate_age(birth_year):
    return curr_year - birth_year if birth_year <= curr_year else 0


def friend_list(request):
    friends = Friend.objects.all().values()
    response = {'friends': friends}
    return render(request, 'friend_list_lab1.html', response)

lab_2/views.py
from django.http import response
from django.http.response import HttpResponse
from django.core import serializers
from django.shortcuts import render
from .models import Note

# Create your views here.
def index(request):
    notes = Note.objects.all().values()
    response = {"notes": notes, "inbox": Note.objects.all().count()}
    return render(request, 'lab2.html', response)

def xml(request):
    data = serializers.serialize('xml', Note.objects.all())
    return HttpResponse(data, content_type="application/xml")

def json(request):
    data = serializers.serialize('json', Note.objects.all())
    return HttpResponse(data, content_type="application/json")

lab_3/views.py
from django.shortcuts import render
from .forms import FriendForm
from lab_1.models import Friend
from django.contrib.auth.decorators import login_required

@login_required(login_url = '/admin/login/')
def index(request):
    friends = Friend.objects.all().values()
    response = {'friends': friends}
    return render(request, 'lab3_index.html', response)

@login_required(login_url = '/admin/login/')
def add_friend(request):
    context = {}
    form = FriendForm(request.POST or None, request.FILES or None)

    if form.is_valid():
        form.save()

    context['form'] = form
    return render(request, "lab3_form.html", context)

lab_4/views.py
from django.shortcuts import render, redirect
from .models import Note
from .forms import NoteForm

# Create your views here.
def index(request):
    notes = Note.objects.all().values()
    response = {"notes": notes, "inbox": Note.objects.all().count()}
    return render(request, 'lab4_index.html', response)

def add_note(request):
    context = {}
    form = NoteForm(request.POST or None, request.FILES or None)

    if form.is_valid():
        form.save()
        response = redirect("/lab-4")
        return response

    context['form'] = form
    return render(request, "lab4_form.html", context)

def note_list(request):
    notes = Note.objects.all().values()
    response = {"notes": notes, "inbox": Note.objects.all().count()}
    return render(request, 'lab4_note_list.html', response)

lab_1/templates/friend_list_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <table>
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      <!-- TODO loop from Friend model -->
      {%if friends%}
        {%for friend in friends%}
        <tr>
          <td> {{ friend.name }} </td>
          <td> {{ friend.npm }} </td>
          <td> {{ friend.birth_date }} </td>
        </tr>
        {% endfor %}
      {% endif %}
      <!-- EXAMPLE SECTION -->
      <tr>
        <td>Asmara Nugi</td>
        <td>1706032156</td>
        <td>May 1, 1999</td>
      </tr>
      <tr>
        <td>Fadli Rais</td>
        <td>1706032370</td>
        <td>Sept 11, 1998</td>
      </tr>
      <!-- END SECTION -->
    </table>
  </body>
</html>

lab_1/templates/index_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>{{ name }}</title>
  </head>
  <body>
    <h1>Hello my name is {{ name }}</h1>
    <article>NPM : {{ npm }}</article>
    <article>I am {{ age }} years old</article>
  </body>
</html>

lab_2/templates/lab2.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
      <h1 style="color:crimson">YOUR INBOX ({{inbox}})</h1>
      {% if notes %}
        {% for note in notes %}

            <p style="background-color:rgb(202, 199, 199)"> To: {{ note.receiver }} </p>
            <p style="background-color:rgb(202, 199, 199)"> From: {{ note.sender }} </p>
            <h3>{{ note.title }} </h3>
            <p style="background-color:rgb(202, 199, 199)"> "{{ note.message }}" </p>
        {% endfor %}
      {% endif %}
      <p style="color:red">No new messages</p>
  </body>
</html>

lab_3/templates/lab3_form.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend Form</title>
  </head>
  <body>
    <h1>Add a Friend!</h1>
      <form action="" method="POST">
        {% csrf_token %}
        <p> Name: <input type="text" name= "name" placeholder="Your Name" maxLength ="30" id="id_name"> <br>
        NPM: <input type="text" name= "npm" placeholder="Your NPM" maxLength ="30" id="id_npm"> <br>
        Date of Birth: <input type="date" name= "birth_date" placeholder="Your Birth Date" maxLength ="30" id="id_dob"> </p>
        <input type="submit" value="Submit">
      </form>
  </body>
  <style>
    body {
      background-image: url("https://wallpaperaccess.com/full/1246198.png");
      background-size: 1600px 900px;
    }
    table, th, td {
      border: 3px solid rgb(116, 65, 65);
      border-color: hotpink;
      border-collapse: collapse;
      padding-right: 10px;
      text-align: left;
      padding: 4px;
      color: pink;
      font-family: "Trebuchet MS";
    }
    h1 {
      font-family: "Trebuchet MS";
      color: hotpink;
      font-size: 75;
    }
    p {
      font-family: "Trebuchet MS";
      color: hotpink;
      font-size: 20;
    }
  </style>
</html>

lab_3/templates/lab3_index.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <h1>Besties List!</h1>
    <table>
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      <!-- TODO loop from Friend model -->
      {%if friends%}
        {%for friend in friends%}
        <tr>
          <td> {{ friend.name }} </td>
          <td> {{ friend.npm }} </td>
          <td> {{ friend.birth_date }} </td>
        </tr>
        {% endfor %}
      {% endif %}
    </table>
  </body>
  <style>
    body {
      background-image: url("https://images.unsplash.com/photo-1533106497176-45ae19e68ba2?ixid=MnwxMjA3fDB8MHxzZWFyY2h8Mnx8bmVvbiUyMHZpYmV8ZW58MHx8MHx8&ixlib=rb-1.2.1&w=1000&q=80");
      background-size: auto;
    }
    table, th, td {
      border: 3px solid rgb(116, 65, 65);
      border-color: hotpink;
      border-collapse: collapse;
      padding-right: 10px;
      text-align: left;
      padding: 4px;
      color: pink;
      font-family: "Trebuchet MS";
    }
    h1 {
      font-family: "Trebuchet MS";
      color: hotpink;
      font-size: 75;
    }
  </style>
</html>

lab_4/templates/lab4_form.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Note Form</title>
  </head>
  <body>
    <ul>
      <li><a href="/lab-4">Table!&nbsp;&nbsp;</a></li>
      <li><a href="note-list">Card!&nbsp;&nbsp;</a></li>
      <li><a href="add-note">Add a Note!</a></li>
    </ul>
    <h1>Add a Note!</h1>
        <form action="" method="POST">
        {% csrf_token %}
        <p>To:<br> <input type="text" name= "receiver" placeholder="This is for" maxLength ="30" id="id_to"> <br>
        From:<br><input type="text" name= "sender" placeholder="This is from" maxLength ="30" id="id_from"> <br>
        Title:<br><input type="text" name= "title" placeholder="This is about" maxLength ="30" id="id_title"> <br>
        Message:<br><input type="text" name= "message" placeholder="What do you want to say?" maxLength ="100" id="id_message">
        </p>
        <input type="submit" value="Submit">
        </form>
  </body>
  <style>
    body {
      background-image: url("https://wallpaperaccess.com/full/1246198.png");
      background-size: 1600px 900px;
    }
    table, th, td {
      border: 3px solid rgb(116, 65, 65);
      border-color: hotpink;
      border-collapse: collapse;
      padding-right: 10px;
      text-align: left;
      padding: 4px;
      color: pink;
      font-family: "Trebuchet MS";
    }
    h1 {
      font-family: "Trebuchet MS";
      color: hotpink;
      font-size: 75;
    }
    p {
      font-family: "Trebuchet MS";
      color: hotpink;
      font-size: 20;
    }
    button {
      border: none;
      background-color: violet;
      color: purple;
      font-family: "Trebuchet MS";
      font-size: 70;
    }
    a {
      font-family: "Trebuchet MS";
      color: hotpink;
      font-size: 20;
      list-style-type: none;
      margin: 0;
      padding: 0;
      text-decoration: none;
    }
    li {
      display: inline;
      text-decoration: none;
    } 
  </style>
</html>

lab_4/templates/lab4_index.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Notes</title>
    <!-- <link rel="stylesheet" href="{% static 'namafile.css' %}"> -->
  </head>
  <body>
    <ul>
      <li><a href="/lab-4">Table!&nbsp;&nbsp;</a></li>
      <li><a href="note-list">Card!&nbsp;&nbsp;</a></li>
      <li><a href="add-note">Add a Note!</a></li>
    </ul>
    <h1>Notes Table!</h1>
    <table>
      <tr>
        <th>Title</th>
        <th>To</th>
        <th>From</th>
        <th>Message</th>
      </tr>
      {% if notes %}
        {% for note in notes %}
        <tr>
          <td> {{ note.title }} </td>
          <td> {{ note.receiver }} </td>
          <td> {{ note.sender }} </td>
          <td> {{ note.message }} </td>
        </tr>
        {% endfor %}
      {% endif %}
    </table>
    <p> </p>
    <button class="button" onclick="location.href='add-note'">Add a Note!</button>

  </body>
  <style>
    body {
      background-image: url("https://images.unsplash.com/photo-1533106497176-45ae19e68ba2?ixid=MnwxMjA3fDB8MHxzZWFyY2h8Mnx8bmVvbiUyMHZpYmV8ZW58MHx8MHx8&ixlib=rb-1.2.1&w=1000&q=80");
      background-size: auto;
    }
    table, th, td {
      border: 3px solid rgb(116, 65, 65);
      border-color: hotpink;
      border-collapse: collapse;
      padding-right: 10px;
      text-align: left;
      padding: 4px;
      color: pink;
      font-family: "Trebuchet MS";
    }
    h1 {
      font-family: "Trebuchet MS";
      color: hotpink;
      font-size: 75;
    }
    button {
      border: none;
      background-color: violet;
      color: purple;
      font-family: "Trebuchet MS";
      font-size: 70;
    }
    a {
      font-family: "Trebuchet MS";
      color: hotpink;
      font-size: 20;
      list-style-type: none;
      margin: 0;
      padding: 0;
      text-decoration: none;
    }
    li {
    display: inline;
    text-decoration: none;
    }
  </style>
</html>

lab_4/templates/lab4_note_list.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Your Notes!</title>
  </head>
  <body>
    <ul>
      <li><a href="/lab-4">Table!&nbsp;&nbsp;</a></li>
      <li><a href="note-list">Card!&nbsp;&nbsp;</a></li>
      <li><a href="add-note">Add a Note!</a></li>
    </ul>
      <div class="container">
        <div class="card__container">
          {% if notes %}
            {% for note in notes %}
              <div class="card">
              <div class="card__content">
              <h2 class="card__title"> {{ note.title }}</h2>
              <h3 class="card__header">{{ note.message }}</h3>
              <p class="card__sender">From: {{ note.sender }}</p>
              <p class="card__receiver">To: {{ note.receiver }}</p>
                </div>
              </div>
            {% endfor %}
          {% endif %}
        </div>
      </div>
  </body>
  <style>
    body {
      background: #191a19;
    }
    a {
      font-family: "Trebuchet MS";
      color: hotpink;
      font-size: 20;
      list-style-type: none;
      margin: 0;
      padding: 0;
      text-decoration: none;
    }
    li {
      display: inline;
      text-decoration: none;
    }   

@import url("https://fonts.googleapis.com/css2?family=Roboto:ital,wght@0,300;0,400;0,500;0,700;1,400&display=swap");
*,
*::before,
*::after {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
  font-family: "Roboto", sans-serif;
}
.container {
  position:absolute;
  width:100%;
  height:100vh;
  background: #2c302d;
}
.card {
  width: 60%;
  height: 80%;
  max-height: 300px;
  padding: auto;
  text-align: center;
  background: #242625;
  border-radius: 10px;
  box-shadow: 25px 25px 50px #1b1c1b, -25px -25px 50px #2d302f;
}
.card__container {
    display: grid;
    width: 100%;
    height: 100%;
    grid-template-columns: 1fr 1fr 1fr;
    align-items: center;
    justify-items: center;
    color: white;
}
.card__content {
    width: 90%;
    height: 95%;
    background: #191a19;
    margin: 10px auto;
    border-radius: 5px;
    padding: 20px;
    cursor: pointer;
    box-shadow:  16px 16px 44px #0a0a0a, -16px -16px 44px #282a28;
    transition: 0.3s all ease-in-out;
}
.card__content:hover{
  margin-top:-10px;
}
.card__header {
    font-size: 20px;
    margin: 40px auto;
  }
.card__button {
    padding: 10px;
    border-radius: 50px;
    background: #1f75c4;
    color: white;
    font-weight: bold;
    cursor: pointer;
    border: none;
    margin: 50px auto;
}
.card__sender {
  /* position: absolute;
  bottom: 1;
  text-align: center; */
}
.card__receiver {
  /* position: absolute;
  bottom: 0;
  text-align: center; */
}
  </style>
</html>